/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.wizardbatlle.Visao;

import br.com.wizardbatlle.modelo.*;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.Toolkit;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.util.ArrayList;
import java.util.Random;

import javax.swing.*;

/**
 *
 * @author Bem vindo
 */

public abstract class Tela extends JPanel implements Runnable, Comuns
{
    private Dimension dimensao;

    private boolean esta_jogando = true;
    private boolean fimdejogo   = false;

    private final String background_imagen = "bg.png";
    private ImageIcon background;

    private Jogador jogador; 
    private Maquina maquina;

    private Thread animador;

    private boolean resultado = false;
    private String resultado_etapa = "";

    private int ultimo = 0;

public Tela ()
{
   addKeyListener(new  Tadapter());

   setFocusable(true);

   this.dimensao = new Dimension(LARGURA, ALTURA);

   background = new ImageIcon(getClass().getResource(background_imagen));

   initJogo();

}

public void initJogo()
{
   Random gerar = new Random();
   ArrayList<Cartas> cartas = new  ArrayList<Cartas> ();

   cartas.add(new Cartas("Saga", gerar.nextInt(99)+1, gerar.nextInt(4)+1, TIPO_CARTAS.defesa));
   cartas.add(new Cartas("Pegasus", gerar.nextInt(99)+1, gerar.nextInt(4)+1, TIPO_CARTAS.defesa));
   cartas.add(new Cartas("Afrodite", gerar.nextInt(99)+1, gerar.nextInt(4)+1, TIPO_CARTAS.ataque));
   cartas.add(new Cartas("Atena", gerar.nextInt(99)+1, gerar.nextInt(4)+1, TIPO_CARTAS.ataque));
   cartas.add(new Cartas("Miro", gerar.nextInt(99)+1, gerar.nextInt(4)+1, TIPO_CARTAS.ataque));
   cartas.add(new Cartas("Shiriu", gerar.nextInt(99)+1, gerar.nextInt(4)+1, TIPO_CARTAS.ataque));

   jogador = new Jogador("Kalasch", "Reino de Gelo", cartas);
   jogador.setAguardando(false);

   ArrayList<Cartas> cartas_maquina = new  ArrayList<Cartas> ();

   cartas_maquina.add(new Cartas("Fenix", gerar.nextInt(99)+1, gerar.nextInt(4)+1, TIPO_CARTAS.defesa));
   cartas_maquina.add(new Cartas("Andromeda", gerar.nextInt(99)+1, gerar.nextInt(4)+1, TIPO_CARTAS.defesa));
   cartas_maquina.add(new Cartas("Zeus", gerar.nextInt(99)+1, gerar.nextInt(4)+1, TIPO_CARTAS.ataque));
   cartas_maquina.add(new Cartas("Poseidon", gerar.nextInt(99)+1, gerar.nextInt(4)+1, TIPO_CARTAS.ataque));
   cartas_maquina.add(new Cartas("Abel", gerar.nextInt(99)+1, gerar.nextInt(4)+1, TIPO_CARTAS.ataque));
   cartas_maquina.add(new Cartas("Mortefus", gerar.nextInt(99)+1, gerar.nextInt(4)+1, TIPO_CARTAS.ataque));

   maquina = new Maquina("Tabov", "Reino de Gelo", cartas_maquina);
   maquina.setAguardando(true);

   if (animador == null ==  !esta_jogando)
   {
      animador = new Thread(this);
      animador.start();
   
   }

}

@Override
public void addNotify()
{
  super.addNotify();
  initJogo();

}

public void desenharStatus (Graphics2D g)
{
   Font estilo  = new Font("Microsoft Sans Serif", Font.CENTER_BASELINE, 58);

   g.setColor(Color.white);

   g.setFont(estilo);

   FontMetrics metrica = this.getFontMetrics(estilo);

   if(resultado)
   {
      g.drawString(resultado_etapa, (LARGURA - metrica.stringWidth(resultado_etapa))/2, ALTURA /2);
      return;
   }

   if(jogador.isAguardando())
   {
      resultado_etapa = "Aguarde a sua vez!";
      g.drawString("Aguarde a sua vez!", (LARGURA - metrica.stringWidth(resultado_etapa))/2, ALTURA /2);
   }
   else
   {
      resultado_etapa = "Aguarde a sua vez!";
      g.drawString("Sua vez de jogar!", (LARGURA - metrica.stringWidth(resultado_etapa))/2, ALTURA /2);   
   
   }
}

public void desenharFimDeJogo(Graphics2D g)
{
   g.setColor(Color.white);
   g.fillRect(0, 0, LARGURA, ALTURA);

   Font estilo  = new Font("Microsoft Sans Serif", Font.CENTER_BASELINE, 38);

   FontMetrics metrica = this.getFontMetrics(estilo);

   g.setColor(Color.BLACK);

   g.setFont(estilo);

   if(fimdejogo)
   {
      g.drawString("Voce perdeu :(", (LARGURA - metrica.stringWidth("Voce perdeu :("))/2, ALTURA /2);
   
   }
   else
   {
      g.drawString("voce ganhou :D", (LARGURA - metrica.stringWidth("Voce ganhou :D"))/2, ALTURA /2);
   
   }

}

@Override
public void paint (Graphics g)
{
    super.paint(g);

    Graphics2D g2 = (Graphics2D) g;
    g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON );

    if(esta_jogando)
    {
       g2.drawImage(background.getImage(), 0, 0, this);
       
       maquina.desenharCarta(g2, this);
       jogador.desenharCartas(g2, this);
       jogador.desenharJogador(g2);
       jogador.desenharValoresCartas(g2, this);
       jogador.desenharStatus(g2);
    
       maquina.desenharJogador(g2);
       maquina.desenharStatus(g2);
       maquina.desenharValoresCartas(g2, this);
    
       desenharStatus(g2);
    
    }
    else
    {
       desenharFimDeJogo(g2);
    
    }

    Toolkit.getDefaultToolkit().sync();
    g.dispose();

}

public void rum ()
{
   long antesTempo, tempoDiferente, sleep; 
   antesTempo = System.currentTimeMillis();

   while (esta_jogando)
   {
      repaint();
   
      ciclo();
   
      if(resultado)
      {
         try   
         {
           Thread.sleep(2500);
         
         }
         catch (InterruptedException e)
         {
            System.out.println(" Erro de interrupcao");   
         
         }
      
         resultado = false;
      
      
      }

      tempoDiferente = System.currentTimeMillis() - antesTempo;
      sleep = DELAY - tempoDiferente;
              
      if(sleep < 0)        
      { sleep = 2; }       
              
      try        
      {
         Thread.sleep(sleep);
      }        
              
      catch (InterruptedException e)        
      {
         System.out.println(" Erro de interrupcao");   
          
      }        
              
      antesTempo = System.currentTimeMillis();
    
   
    }
   
      repaint();
}

public void ciclo ()
{
    jogador.liberarCarta();
    maquina.liberarCarta();

    if( jogador.emJogo() && jogador.isAguardando() && !maquina.emJogo())
    {
        try
        {
           Thread.sleep(2500);
        }        
              
           catch (InterruptedException e)        
        {
           System.out.println(" Erro de interrupcao");   
          
        }   
        
        maquina.atuar(jogador.cartaEmJogo());
    
        jogador.setAguardando(false);
            
    }
    else if( !jogador.emJogo() && jogador.isAguardando() && maquina.isAguardando() && maquina.emJogo())
    {
        try
        {
           Thread.sleep(2500);
        }        
              
           catch (InterruptedException e)        
        {
           System.out.println(" Erro de interrupcao");   
          
        }   
        
        maquina.primeiraJogada();
    
        jogador.setAguardando(false);
    
    }
    
    if( jogador.emJogo() && maquina.emJogo())
    {
       repaint();
    
       resultado       = true;
       resultado_etapa = jogador.cartaEmJogo().getNome();
    
       try
        {
           Thread.sleep(2500);
        }        
              
           catch (InterruptedException e)        
        {
           System.out.println(" Erro de interrupcao");   
          
        }   
        
        Cartas carta_jogador = jogador.cartaEmJogo();
        Cartas carta_maquina = maquina.cartaEmJogo();
    
        int forca;
    
        jogador.setPoder(carta_jogador.getForca());
        maquina.setPoder(carta_maquina.getForca());
    
        if ( carta_jogador.getTipocarta() == TIPO_CARTAS.ataque
                  && carta_maquina.getTipocarta() == TIPO_CARTAS.ataque) 
    
        {
            if( carta_jogador.getNivel() > carta_maquina.getNivel() )
            {
               forca = (( carta_jogador.getNivel() - 1) * 100) * carta_jogador.getForca();
            
               maquina.setVida(forca);
            
               forca = (( carta_maquina.getNivel() - 1) * 100) *
                       (( carta_maquina.getForca() / MAXIMO_NIVEL) * carta_maquina.getNivel() );
            
               jogador.setVida(forca);       
                       
               resultado_etapa = " Voce se saiu melhor!";        
                       
            }
            else if( carta_jogador.getNivel() < carta_maquina.getNivel())
            {
               forca = (( carta_maquina.getNivel() - 1) * 100) *  carta_maquina.getForca();
            
               jogador.setVida(forca);
            
               forca = (( carta_jogador.getNivel() - 1) * 100) *
                       (( carta_jogador.getForca() / MAXIMO_NIVEL) * carta_jogador.getNivel() );
            
               maquina.setVida(forca);
            
               resultado_etapa = maquina.getNome() + " se saiu melhor";
            
            }
            else if( carta_jogador.getNivel() == carta_maquina.getNivel())
            {
               forca = (( carta_jogador.getNivel() - 1) * 100) *  carta_jogador.getForca();
            
               maquina.setVida(forca);
            
               forca = (( carta_maquina.getNivel() - 1) * 100) * carta_maquina.getForca() ;
            
               jogador.setVida(forca);
            
               resultado_etapa = " Ambos foram bem";
            
            }
            else if( carta_jogador.getTipocarta() == TIPO_CARTAS.defesa
                   &&  carta_maquina.getTipocarta() == TIPO_CARTAS.ataque)
        
            {
               if( carta_jogador.getNivel() >= carta_maquina.getNivel())
               {
                  if( carta_jogador.getForca() > carta_maquina.getForca())
                  {
                     forca = carta_jogador.getForca() - carta_maquina.getForca(); 
                  
                     maquina.setVida(forca);
                  }
               
                  resultado_etapa = " Voce se saiu melhor";
               }
               else
               {
                  int forca_defesa = (( carta_jogador.getNivel() - 1) * 100 ) * carta_jogador.getForca();
                  int forca_ataque = (( carta_maquina.getNivel() - 1) * 100 ) * carta_maquina.getForca();
               
                  jogador.setVida(forca_ataque - forca_defesa);
               
                  resultado_etapa = maquina.getNome() + " Se saiu melhor!";
               
               
               }
            
    
            }   
            else if ( carta_jogador.getTipocarta() == TIPO_CARTAS.ataque   
                    && carta_maquina.getTipocarta() == TIPO_CARTAS.defesa)
                
            {
                 if ( carta_maquina.getNivel() >= carta_jogador.getNivel())
                 {
                      if ( carta_maquina.getForca() > carta_jogador.getForca())     
                      {
                          forca =  carta_maquina.getForca() - carta_jogador.getForca();
                      
                          jogador.setVida(forca);
                      }
                          resultado_etapa = maquina.getNome() + " Se saiu melhor";
                 }
                 else
                 {
                      int forca_defesa = (( carta_maquina.getNivel() - 1) * 100 ) * carta_maquina.getForca();
                      int forca_ataque = (( carta_jogador.getNivel() - 1) * 100 ) * carta_jogador.getForca();      
                 
                      maquina.setVida(forca_ataque - forca_defesa);
                 
                      resultado_etapa = "Voce se saiu melhor";
                 }

            }
            
            maquina.resetar();
            jogador.resetar();
        
            if ( jogador.isAguardando() && maquina.isAguardando())
            {
                jogador.setAguardando(false);
                maquina.setAguardando(true);
            
            }
            else
            {
                jogador.setAguardando( !jogador.isAguardando());
                maquina.setAguardando( !maquina.isAguardando());
            
            }
        
            jogador.diminuirEspera();
            maquina.diminuirEspera();
        
            if ( jogador.getVida() <= 0)
            {
                jogador.zeraVida();
            
            }
        
            if ( maquina.getVida() <= 0)
            {
                 maquina.zeraVida();
            
            }
        
            if ( jogador.getPoder() <= 0)
            {
                 jogador.setAumentodoPoder(0);
            
            }
                
            if ( maquina.getPoder() <= 0)
            {
                 maquina.setAumentodoPoder(0);
            
            }    
                
            repaint();   
                
            try    
            {
                 Thread.sleep(1000);
            
            }    
            catch (InterruptedException e)   
            {
                 System.out.println( " Erro de interrupcao!");
            
            }    
                
         }       
        
        }   

        if ( jogador.getVida() <= 0)
        {
            esta_jogando = false;
            fimdejogo = true;
        
        }
        else if ( maquina.getVida() <= 0)
        {
           esta_jogando = false;
        
        }
    
        if ( jogador.getPoder() <= 0)
        {
            jogador.setVida(50);
            jogador.setAumentodoPoder(0);
            jogador.liberarTodasCarta();
        
            if ( jogador.getVida() <= 0)
            {
                 jogador.zeraVida();
            
            }
        
            resultado_etapa = " Carregando seu poder ";
        
            int poder = 0;
        
            while (jogador.getPoder() != 500)
            {
                poder++;
            
                jogador.setAumentodoPoder(poder);
            
                repaint();
            
                try
                {
                   Thread.sleep(5);
                
                }
                catch ( InterruptedException e)
                {
                   System.out.println(" Erro de interrupcao");
                }
            
            }
        
        }
        else if ( maquina.getPoder() <= 0)
        {
            maquina.setVida(50);
            maquina.setAumentodoPoder(0);
            maquina.liberarTodasCarta();
        
            if ( maquina.getVida() <= 0)
            {
                 maquina.zeraVida();
            
            }
        
            resultado_etapa = " Carregando o poder de " + maquina.getNome() + "!";
        
            int poder = 0;
        
            while (maquina.getPoder() != 500)
            {
                poder++;
            
                maquina.setAumentodoPoder(poder);
            
                repaint();
            
                try
                {
                   Thread.sleep(5);
                
                }
                catch ( InterruptedException e)
                {
                   System.out.println(" Erro de interrupcao");
                }
            }
        
        
    }


}

private class Tadapter extends KeyAdapter
{
     
     public void KeyReleased(KeyEvent e)
     {
        jogador.KeyReleased(e);
     
     }

     // DEFINE O METODO DE TECLA DO JOGADOR
     public void KeyPressed(KeyEvent e)
     {
        // O JOGADOR SE MOVIMENTA
        jogador.KeyPressed(e);
     }
     
}

}

